'use strict';

exports.__esModule = true;

exports.default = function (path, expectedExtention) {
    var correctedPath = path.replace(/\\/g, '/').split('/').map(function (str) {
        return (0, _sanitizeFilename2.default)(str);
    }).join('/');

    if (!expectedExtention) return correctedPath;

    var extentionRe = new RegExp((0, _lodash.escapeRegExp)(expectedExtention));

    return extentionRe.test(correctedPath) ? correctedPath : correctedPath + '.' + expectedExtention;
};

var _sanitizeFilename = require('sanitize-filename');

var _sanitizeFilename2 = _interopRequireDefault(_sanitizeFilename);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];